# -*- coding: utf-8 -*-
# Embedded file name: /media/build/vti-dorie/build/tmp/work/armv7ahf-vfp-neon-oe-linux-gnueabi/enigma2-python/enigma2-python-vti-15.0.0-20200921-r00r01/git/lib/python/Screens/MyEpgSelecti.py
from Screen import Screen
from Components.config import config, ConfigClock, ConfigInteger, ConfigSubsection
from Components.Button import Button
from Components.Pixmap import Pixmap
from Components.Label import Label
from Components.EpgList import EPGList, EPG_TYPE_SINGLE, EPG_TYPE_SIMILAR, EPG_TYPE_MULTI, EPG_TYPE_EPGBAR
# 0=SINGLE, 1=MULTI, 2=SIMILAR, 3=EPGBAR
from Components.ActionMap import ActionMap, NumberActionMap, HelpableActionMap
from Components.TimerSanityCheck import TimerSanityCheck
from Components.UsageConfig import preferredTimerPath
from Components.Sources.ServiceEvent import ServiceEvent
from Components.Sources.Event import Event
from Components.Sources.StaticText import StaticText
from Components.Sources.ExtEvent import ExtEvent
from Screens.ChoiceBox import ChoiceBox
from Screens.TimerEdit import TimerSanityConflict, TimerEditList
from Screens.MyEventVi import EventViewSimple, EventViewEPGSelect
from Screens.MessageBox import MessageBox
from Screens.HelpMenu import HelpableScreen
from TimeDateInput import TimeDateInput
from enigma import eServiceReference, eEPGCache, eEnv, eServiceCenter
from RecordTimer import RecordTimerEntry, parseEvent, AFTEREVENT
from TimerEntry import TimerEntry
from ServiceReference import ServiceReference
from time import localtime, time, sleep
from time import mktime, strftime #+ WeFraJo
from datetime import date, datetime #+ WeFraJo
import os
import Tools.AutoTimerHook as AutoTimerHook

from Components.ServiceEventTracker import ServiceEventTracker, InfoBarBase
from enigma import iPlayableService, eWidget

from threading import Thread  #Test

mepg_config_initialized = False


class MyEPGSelecti(Screen):
	EMPTY = 0
	ADD_TIMER = 1
	REMOVE_TIMER = 2
	ENABLE_TIMER = 3
	ZAP = 1

	def __init__(self, session, service, zapFunc = None, eventid = None, bouquetChangeCB = None, serviceChangeCB = None, isEPGBar = None, switchBouquet = None, EPGNumberZap = None, togglePiP = None):
		Screen.__init__(self, session)
		
		self.parent = session #+ WeFraJo
		self.xSession = session
		self.xService = service
		if not AutoTimerHook.CHECKAUTOTIMER:
			AutoTimerHook.initAutoTimerGlobals()
		self.screentitle = _('EPG Selection')
		self.bouquetChangeCB = bouquetChangeCB
		self.serviceChangeCB = serviceChangeCB
		self.switchBouquet = switchBouquet
		self.EPGNumberZap = EPGNumberZap
		self.togglePiP = None
		self.ask_time = -1
		self.init_1() #+ WeFraJo
		self['key_red'] = Button('')
		self.closeRecursive = False
		self.saved_title = None
		self['Service'] = ServiceEvent()
		self['Event'] = Event()
		self['SelectedEvent'] = StaticText()
		self['ExtEvent'] = ExtEvent()
		if isinstance(service, str) and eventid != None:
			self.type = EPG_TYPE_SIMILAR
			#self.close() #+ WeFraJo
			self.skinName = ['myEPGSelection'] #+ WeFraJo
			self['key_yellow'] = Button()
			self['key_blue'] = Button()
			self['key_red'] = Button()
			self.currentService = service
			self.eventid = eventid
			self.zapFunc = None
		elif isEPGBar and (isinstance(service, eServiceReference) or isinstance(service, str)):
			self.close() #+ WeFraJo
			self.skinName = ['EPGSelectionEPGBar_SD']
			if session.desktop.size().width() > 720:
				self.skinName = ['EPGSelectionEPGBar_HD']
			self.type = EPG_TYPE_EPGBAR
			self['key_yellow'] = Button()
			self['key_blue'] = Button()
			self.currentService = ServiceReference(service)
			self.zapFunc = zapFunc
			self.togglePiP = togglePiP
			self.sort_type = 0
			self.setSortDescription()
			self['EPGBarActions'] = ActionMap(['DirectionActions', 'OkCancelActions', 'InfobarSeekActions'], {'cancel': self.closeScreen,
			 'ok': self.zapTo,
			 'left': self.prevService,
			 'right': self.nextService,
			 'playpauseService': self.setPiPService}, -1)
			self['EPGBarActions'].csel = self
		elif isinstance(service, eServiceReference) or isinstance(service, str):
			self.type = EPG_TYPE_SINGLE
			self.skinName = ['myEPGSelection'] #+WeFraJo
			self['key_yellow'] = Button()
			self['key_blue'] = Button()
			self.currentService = ServiceReference(service)
			self.zapFunc = zapFunc
			self.sort_type = 0
			self.setSortDescription()
			self.services = service #+ WeFraJo ???
		else:
			self.skinName = 'myEPGSelectionMulti'
			self.type = EPG_TYPE_MULTI
			self['key_yellow'] = Button(_('Prev'))
			self['key_blue'] = Button(_('Next'))
			self['now_button'] = Pixmap()
			self['next_button'] = Pixmap()
			self['more_button'] = Pixmap()
			self['now_button_sel'] = Pixmap()
			self['next_button_sel'] = Pixmap()
			self['more_button_sel'] = Pixmap()
			self['now_text'] = Label()
			self['next_text'] = Label()
			self['more_text'] = Label()
			self['date'] = Label() #necessary for AEL
			self['askDateTime'] = Label()
			self.services = service
			self.zapFunc = zapFunc
		#self['key_green'] = Button(_('Add timer')) #- WeFraJo
		self['key_green'] = Button("Timer hinzufügen") #+ WeFraJo
		self['zapTo'] = Label()
		self.key_green_choice = self.ADD_TIMER
		self.key_red_choice = self.EMPTY
		self['list'] = EPGList(type=self.type, selChangedCB=self.onSelectionChanged, timer=session.nav.RecordTimer)
		self['actions'] = ActionMap(['myEPGSelectActions', 'OkCancelActions'], {'cancel': self.closeScreen,
		 'timerAdd_orig': self.timerAdd,
		 'timerEnableDisable_orig': self.timerEnableDisable,
		 'instantToggleTimerState_orig': self.instantToggleTimerState,
		 'instantTimer_orig': self.addInstantTimer,
		 'yellow': self.yellowButtonPressed,
		 'blue': self.blueButtonPressed,
		 'info': self.infoKeyPressed,
		 'red_orig': self.zapTo,
		 'input_date_time': self.enterDateTime,
		 'nextBouquet_orig': self.nextBouquet,
		 'prevBouquet_orig': self.prevBouquet,
		 'next': self.nextService,
		 'previous': self.prevService,
		 'record': self.addInstantTimer,
		# 'ok': self.zapTo,
		 'ok': self.key_ok,
		 'subtitle': self.key_test,
		 'green': self.key_currentNextPlaying,
		 'video': self.key_minusMinutes,
		 'menu': self.key_plusMinutes,
		 'text': self.key_setMinutes,
		 'pageDown': self.key_pageUp,
		 'pageUp': self.key_pageDown,
		 'rewind': self.key_minus1day,
		 'play': self.key_minus6hours,
		 'pause': self.key_plus6hours,
		 'fastforward': self.key_plus1day,
		 'red': self.key_primetime,
		 'red_long': self.enterDateTime,
		 'tv': self.key_instantBacktoTV,
		 'moveUp': self.key_moveUp,
		 'moveDown': self.key_moveDown,
		 'key_0': self.selectCurrentPlaying,
		 'audio': self.toggleSingleMulti,
		 'notused': self.key_notused}) #mod WeFraJo
		self['actions'].csel = self
		if EPGNumberZap:
			self['EPGBarNumberActions'] = NumberActionMap(['NumberActions'], {'1': self.keyNumberGlobal,
			 '2': self.keyNumberGlobal,
			 '3': self.keyNumberGlobal,
			 '4': self.keyNumberGlobal,
			 '5': self.keyNumberGlobal,
			 '6': self.keyNumberGlobal,
			 '7': self.keyNumberGlobal,
			 '8': self.keyNumberGlobal,
			 '9': self.keyNumberGlobal})
		#self['menu_actions'] = HelpableActionMap(self, 'MenuActions', {'menu': (self.menuClicked, _('Setup'))}, -2)
		#print "WeFraJo EpgSelection init type xxxx7 ", self.type
		self.init_2()

		self.onLayoutFinish.append(self.onCreate)

		return


	def menuClicked(self):
		return #+ WeFraJo
		if self.type == EPG_TYPE_MULTI:
			#self.enterDateTime() #- WeFraJo
			self.key_plusMinutes() #+ WeFraJo
		else:
			return #+ WeFraJo
			from Plugins.SystemPlugins.VTIPanel.EPGPanel import EPGPanel
			self.session.open(EPGPanel, '/usr/lib/enigma2/python/Plugins/systemPlugins/VTIPanel')

	def setPiPService(self):
		lst = self['list']
		ref = lst.getCurrent()[1]
		if not ref:
			ref = self.currentService
		self.togglePiP(ref.ref)

	def keyNumberGlobal(self, number):
		self.EPGNumberZap(number, self)

	def bouquetSwitcher(self, direction):
		if direction:
			lst = self['list']
			count = lst.getCurrentChangeCount()
			if count == 0:
				ref = lst.getCurrent()[1]
				if not ref:
					ref = self.currentService
				self.switchBouquet(ref.ref, direction, self)

	def nextBouquet(self):
		return #+ WeFraJo 20221125
		if self.bouquetChangeCB:
			self.bouquetChangeCB(1, self)
		elif self.switchBouquet:
			self.bouquetSwitcher(1)

	def prevBouquet(self):
		return #+ WeFraJo 20221125
		if self.bouquetChangeCB:
			self.bouquetChangeCB(-1, self)
		elif self.switchBouquet:
			self.bouquetSwitcher(-1)

	def nextService(self):
		if self.serviceChangeCB:
			#self.serviceChangeCB(1, self) #- WeFraJo
			self.serviceChangeSingleList(1) #+ WeFraJo
		else:  #+ WeFraJo
			self.timeNavigation(1) #+ WeFraJo

	def prevService(self):
		if self.serviceChangeCB:
			#self.serviceChangeCB(-1, self)  #- WeFraJo
			self.serviceChangeSingleList(-1) #+ WeFraJo
		else:  #+ WeFraJo
			self.timeNavigation(-1) #+ WeFraJo

	def enterDateTime(self):
		global mepg_config_initialized
		if self.type == EPG_TYPE_MULTI:
			if not mepg_config_initialized:
				config.misc.prev_mepg_time = ConfigClock(default=time())
				mepg_config_initialized = True
			self.session.openWithCallback(self.onDateTimeInputClosed, TimeDateInput, config.misc.prev_mepg_time)

	def onDateTimeInputClosed(self, ret):
		#print "WeFraJo EpgSelection onDateTimeInputClosed ", ret, config.misc.prev_mepg_time.value
		if len(ret) > 1:
			if ret[0]:
				self.ask_time = -1
				self.getPrimetimeEventStr()
				#self.ask_time = ret[1] #- WeFraJo
				#self.myAsktime = max(time(), ret[1])  #+ WeFraJo
				#self.setConfigAsktime(self.myAsktime) #+ WeFraJo
				#self['list'].fillMultiEPG(self.services, ret[1]) #- WeFraJo


	def closeScreen(self):
		self.beforeClose() #+ WeFraJo
		self.close(self.closeRecursive)

	def key_ok(self):
		if config.plugins.MyEPG.okAction.value == "detail":
			self.infoKeyPressed()
		else:
			self.zapTo()



	def infoKeyPressed(self):
		cur = self['list'].getCurrent()
		event = cur[0]
		service = cur[1]
		if event is not None:
			if self.type != EPG_TYPE_SIMILAR:
				self.session.open(EventViewSimple, event, service, self.eventViewCallback, self.openSimilarList)
			else:
				self.session.open(EventViewSimple, event, service, self.eventViewCallback)
		return

	def openSimilarList(self, eventid, refstr):
		self.session.open(MyEPGSelecti, refstr, None, eventid)
		return

	def setServices(self, services):
		self.services = services
		self.onCreate()

	def setService(self, service):
		self.currentService = service
		self.onCreate()

	def onCreate(self):
		self.ref_currentPlaying = self.session.nav.getCurrentlyPlayingServiceReference().toString()
		l = self['list']
		l.recalcEntrySize()
		if self.type == EPG_TYPE_MULTI and 1==2:
			l.fillMultiEPG(self.services, self.myAsktime)
			if self.last_reference == None:
				l.moveToService(self.session.nav.getCurrentlyPlayingServiceReference())
			else:
				xService = ServiceReference(self.getCurrentInfo()[2])
				l.moveToService(xService.ref)
				#print "xxxj ", xService.ref
			#self.subserviceSelection()
			#self['Service'].newService(cur[1].ref)
		#+ end WeFraJo

		if self.type == EPG_TYPE_MULTI:
			#l.fillMultiEPG(self.services, self.ask_time) #- WeFraJo
			#l.moveToService(self.session.nav.getCurrentlyPlayingServiceReference()) #- WeFraJo
		#+ start WeFraJo: select last selected service in list
			#bouquetServices = []
			new_idx = -1
			idx = 0
			for xService in self.services:
				#bouquetServices.append(str(xService))
				if str(xService) == self.last_reference:
					new_idx = idx
					break
				idx += 1
			curPlayRef = self.session.nav.getCurrentlyPlayingServiceReference()
			movetoRef = curPlayRef
			if self.last_reference == None or self.reset_ref_time:
				self.last_reference = movetoRef.toString()
				config.plugins.MyEPG.ref.setValue(self.last_reference)
			elif new_idx > -1:
				movetoRef = self.services[new_idx].ref
			#print "xxxx2 ", new_idx, xService, str(xService), self.last_reference, xService.ref
			l.fillMultiEPG(self.services, self.myAsktime)
			l.moveToService(movetoRef)
		#+ end WeFraJo

		elif self.type == EPG_TYPE_SINGLE:
			service = self.currentService
			#print "xxxe ", service
			curPlayRef = self.session.nav.getCurrentlyPlayingServiceReference().toString()
			if self.last_reference == None or self.reset_ref_time: # or curPlayRef != self.ref_playing_on_exit or curPlayRef == self.last_reference: nicht!!
				self.reset_ref_time = False
				#service = self.currentService
				service = ServiceReference(curPlayRef)
			else:
				service = ServiceReference(self.last_reference)
				self.findSingleIndex(self.last_reference) 
			#print "xxxf ", self.currentService, ServiceReference(self.last_reference)
			self['Service'].newService(service.ref)
			if self.saved_title is None:
				self.saved_title = self.instance.getTitle()
			title = self.saved_title + ' - ' + service.getServiceName()
			self.instance.setTitle(title)
			l.fillSingleEPG(service)
			self.serviceChangeSingleList(0) #+ WeFraJo
		elif self.type == EPG_TYPE_EPGBAR:
			service = self.currentService
			self['Service'].newService(service.ref)
			l.fillEPGBar(service)
		else:
			l.fillSimilarList(self.currentService, self.eventid)
		self.setTitle(self.screentitle)
		self.createListInfoLabels() #+ WeFraJo
		return

	def updateList(self):
		self['list'].reload()

	def eventViewCallback(self, setEvent, setService, val):
		l = self['list']
		old = l.getCurrent()
		if val == -1:
			self.moveUp()
		elif val == +1:
			self.moveDown()
		cur = l.getCurrent()
		if self.type == EPG_TYPE_MULTI and cur[0] is None and cur[1].ref != old[1].ref:
			self.eventViewCallback(setEvent, setService, val)
		else:
			setService(cur[1])
			setEvent(cur[0])
		return

	def zapTo(self):
		if self.zapFunc and self.key_red_choice == self.ZAP:
			lst = self['list']
			count = lst.getCurrentChangeCount()
			#if count == 0: #- WeFraJo
			if count == 0 or (self.type == EPG_TYPE_MULTI and self.nextSel): #+ WeFraJo
				self.closeRecursive = True
				ref = lst.getCurrent()[1]
				ref2 = str(ref)

				if not ref:
					ref = self.currentService
				check_bouquet = False
				if self.type == EPG_TYPE_EPGBAR or self.type == EPG_TYPE_SINGLE:
					check_bouquet = True
				self.zapFunc(ref.ref, check_bouquet) #change to selected service
				if self.type == EPG_TYPE_EPGBAR:
					self.closeScreen()
				elif self.type == EPG_TYPE_SINGLE and not config.usage.servicelist_preview_mode.value:
					#self.closeScreen() #- WeFraJo
					self.zapActions(ref2) #+ WeFraJo
				else: #+ WeFraJo
					self.zapActions(ref2) #+ WeFraJo

	def eventSelected(self):
		#self.infoKeyPressed() #- WeFraJo
		self.zapTo() #+ WeFraJo

	def yellowButtonPressed(self):
		if 1 == 2:
			cur = self['list'].getCurrent()
			event = cur[0]
			service = cur[1]
			#session = self.session
			if event is not None:
				if self.type != EPG_TYPE_SIMILAR:
					#print "xxx8 ", event, service
					self.session.open(EPGSelection, self.xSession, self.xService) #, service, self.eventViewCallback, self.openSimilarList)
					#self.session.open(EventViewSimple, event, service, self.eventViewCallback, self.openSimilarList) #+ WeFraJo
				else:
					self.session.open(EventViewSimple, event, service, self.eventViewCallback)
			return

		if self.type == EPG_TYPE_MULTI:
			self.ask_time = -1
			self.minusMinutes()
			#self['list'].updateMultiEPG(-1) #- WeFraJo
		elif self.type == EPG_TYPE_SINGLE or self.type == EPG_TYPE_EPGBAR:
			if self.sort_type == 0:
				self.sort_type = 1
			else:
				self.sort_type = 0
			self['list'].sortSingleEPG(self.sort_type)
			self.setSortDescription()

	def setSortDescription(self):
		if self.sort_type == 1:
			#self['key_yellow'].setText(_('Sort Time')) #- WeFraJo
			self['key_yellow'].setText(('Sort: A-Z --> Zeit')) #+WeFraJo
		else:
			#self['key_yellow'].setText(_('Sort A-Z')) #- WeFraJo
			self['key_yellow'].setText(('Sort: Zeit --> A-Z')) #+WeFraJo

	def blueButtonPressed(self):
		if self.type == EPG_TYPE_MULTI:
			self.plusMinutes()
			self.ask_time = -1
			#self['list'].updateMultiEPG(1) #- WeFraJo

	def removeTimer(self, timer, instantTimer = False):
		timer.afterEvent = AFTEREVENT.NONE
		self.session.nav.RecordTimer.removeEntry(timer)
		#self['key_green'].setText(_('Add timer')) #- WeFraJo
		self['key_green'].setText("Timer hinzufügen")
		self.key_green_choice = self.ADD_TIMER
		if instantTimer:
			self.updateList()

	def addInstantTimer(self):
		self.timerAdd(True)

	def timerAdd(self, instantTimer = False):
		cur = self['list'].getCurrent()
		event = cur[0]
		serviceref = cur[1]
		if event is None:
			return
		else:
			eventid = event.getEventId()
			refstr = serviceref.ref.toString()
			if self.key_green_choice == self.ENABLE_TIMER:
				for timer in self.session.nav.RecordTimer.processed_timers:
					if timer.eit == eventid and timer.service_ref.ref.toString() == refstr and timer.disabled == True:
						if instantTimer:
							self.removeTimer(timer, True)
						else:
							cb_func = lambda ret: not ret or self.removeTimer(timer)
							self.session.openWithCallback(cb_func, MessageBox, _('Do you really want to delete %s?') % event.getEventName())
						break

			else:
				for timer in self.session.nav.RecordTimer.timer_list:
					if timer.eit == eventid and timer.service_ref.ref.toString() == refstr:
						if instantTimer:
							self.removeTimer(timer, True)
						else:
							cb_func = lambda ret: not ret or self.removeTimer(timer)
							self.session.openWithCallback(cb_func, MessageBox, _('Do you really want to delete %s?') % event.getEventName())
						break
				else:
					newEntry = RecordTimerEntry(serviceref, checkOldTimers=True, dirname=preferredTimerPath(), allow_duplicate=config.usage.timer_allow_duplicate.value, *parseEvent(event))
					if instantTimer:
						if config.usage.timer_ask_path.value and config.movielist.videodirs.value:
							choicelist = []
							for x in config.movielist.videodirs.value:
								choicelist.append((x, x))

							idx = 0
							pref = (preferredTimerPath(), preferredTimerPath())
							if pref in choicelist:
								idx = choicelist.index(pref)
							self.session.openWithCallback(self.askTimerPath, ChoiceBox, title=_('Timer record location'), list=choicelist, selection=idx)
						else:
							self.session.nav.RecordTimer.saveTimer()
							self.finishedAdd((True, newEntry), True)
					elif AutoTimerHook.AUTOTIMER_OK and config.usage.ask_for_timer_typ.value:
						self.session.openWithCallback(self.askTimerType, ChoiceBox, title=_('Select timer type...'), list=AutoTimerHook.getChoiceList())
					else:
						self.session.openWithCallback(self.finishedAdd, TimerEntry, newEntry)

			return

	def askTimerPath(self, ret = None):
		if ret and ret[0] and os.path.exists(ret[0]):
			cur = self['list'].getCurrent()
			event = cur[0]
			serviceref = cur[1]
			if event is None:
				return
			newEntry = RecordTimerEntry(serviceref, checkOldTimers=True, dirname=ret[0], allow_duplicate=config.usage.timer_allow_duplicate.value, *parseEvent(event))
			self.session.nav.RecordTimer.saveTimer()
			self.finishedAdd((True, newEntry), True)
		return

	def askTimerType(self, ret = None):
		if ret:
			cur = self['list'].getCurrent()
			event = cur[0]
			serviceref = cur[1]
			if event is None:
				return
			if ret[1] == 'default':
				newEntry = RecordTimerEntry(serviceref, checkOldTimers=True, dirname=preferredTimerPath(), allow_duplicate=config.usage.timer_allow_duplicate.value, *parseEvent(event))
				self.session.openWithCallback(self.finishedAdd, TimerEntry, newEntry)
			elif ret[1] == 'autotimer':
				AutoTimerHook.addAutotimerFromEvent(self.session, evt=event, service=serviceref)
			elif ret[1] == 'show_autotimer':
				AutoTimerHook.AutoTimerOverView(self.session)
			elif ret[1] == 'show_timerlist':
				self.session.open(TimerEditList)
		return

	def finishedAdd(self, answer, instantTimer = False):
		vtilog('finished add')
		if answer[0]:
			entry = answer[1]
			simulTimerList = self.session.nav.RecordTimer.record(entry)
			if simulTimerList is not None:
				for x in simulTimerList:
					if x.setAutoincreaseEnd(entry):
						self.session.nav.RecordTimer.timeChanged(x)

				simulTimerList = self.session.nav.RecordTimer.record(entry)
				if simulTimerList is not None:
					self.session.openWithCallback(self.finishSanityCorrection, TimerSanityConflict, simulTimerList)
			#self['key_green'].setText(_('Remove') + '\n' + _('Disable timer')) #- WeFraJo
			self['key_green'].setText("Timer entfernen") #+WeFraJo
			self.key_green_choice = self.REMOVE_TIMER
			if instantTimer:
				self.updateList()
		else:
			#self['key_green'].setText(_('Add timer')) #- WeFraJo
			self['key_green'].setText("Timer hinzufügen") #+WeFraJo
			self.key_green_choice = self.ADD_TIMER
			vtilog('Timeredit aborted')
		return

	def instantToggleTimerState(self):
		self.timerEnableDisable(True)

	def timerEnableDisable(self, instant_toggle = False):
		cur = self['list'].getCurrent()
		event = cur[0]
		serviceref = cur[1]
		if event is None:
			return
		else:
			eventid = event.getEventId()
			refstr = serviceref.ref.toString()
			if self.key_green_choice == self.REMOVE_TIMER:
				for timer in self.session.nav.RecordTimer.timer_list:
					if timer.eit == eventid and timer.service_ref.ref.toString() == refstr:
						if instant_toggle:
							self.toggleTimerState(timer, True, True)
						else:
							cb_func = lambda ret: not ret or self.toggleTimerState(timer, True, False)
							self.session.openWithCallback(cb_func, MessageBox, _('Do you really want to disable timer:') + '\n' + event.getEventName() + ' ?')
						return

			elif self.key_green_choice == self.ENABLE_TIMER:
				for timer in self.session.nav.RecordTimer.processed_timers:
					if timer.eit == eventid and timer.service_ref.ref.toString() == refstr and timer.disabled == True:
						if instant_toggle:
							self.toggleTimerState(timer, False, True)
						else:
							cb_func = lambda ret: not ret or self.toggleTimerState(timer, False, False)
							self.session.openWithCallback(cb_func, MessageBox, _('Do you really want to enable timer:') + '\n' + event.getEventName() + ' ?')
						return

			return

	def toggleTimerState(self, timer, disableTimer, instant_toggle):
		if disableTimer:
			timer.disable()
			self.session.nav.RecordTimer.timeChanged(timer)
			#self['key_green'].setText(_('Remove') + '\n' + _('Enable timer')) #- WeFraJo
			self['key_green'].setText("Timer entfernen") #+WeFraJo
			self.key_green_choice = self.ENABLE_TIMER
		else:
			timer.enable()
			timersanitycheck = TimerSanityCheck(self.session.nav.RecordTimer.timer_list, timer)
			if not timersanitycheck.check():
				timer.disable()
				self['key_green'].setText('')
				self.key_green_choice = self.EMPTY
				simulTimerList = timersanitycheck.getSimulTimerList()
				if simulTimerList is not None:
					self.session.openWithCallback(self.finishedEdit, TimerSanityConflict, simulTimerList)
			elif timersanitycheck.doubleCheck():
				timer.disable()
				#self['key_green'].setText(_('Remove') + '\n' + _('Enable timer')) #- WeFraJo
				self['key_green'].setText("Timer entfernen") #+WeFraJo
				self.key_green_choice = self.REMOVE_TIMER
			self.session.nav.RecordTimer.timeChanged(timer)
		self.updateList()
		return

	def finishedEdit(self, answer):
		if answer[0]:
			entry = answer[1]
			timersanitycheck = TimerSanityCheck(self.session.nav.RecordTimer.timer_list, entry)
			success = False
			if not timersanitycheck.check():
				simulTimerList = timersanitycheck.getSimulTimerList()
				if simulTimerList is not None:
					for x in simulTimerList:
						if x.setAutoincreaseEnd(entry):
							self.session.nav.RecordTimer.timeChanged(x)

					if not timersanitycheck.check():
						simulTimerList = timersanitycheck.getSimulTimerList()
						if simulTimerList is not None:
							self.session.openWithCallback(self.finishedEdit, TimerSanityConflict, timersanitycheck.getSimulTimerList())
					else:
						success = True
			else:
				success = True
			if success:
				self.session.nav.RecordTimer.timeChanged(entry)
		else:
			vtilog('Timeredit aborted')
		return

	def finishSanityCorrection(self, answer):
		self.finishedAdd(answer)

	def moveUp(self):
		if self.isNotSearch:
			ref = self.getCurrentInfo()[2]
			if ref == self.first_bouquet_ref:
				return
			self['list'].moveUp()

	def moveDown(self):
		if self.isNotSearch:
			ref = self.getCurrentInfo()[2]
			if ref == self.last_bouquet_ref:
				return
			self['list'].moveDown()

	def applyButtonState(self, state):
		if state == 0:
			self['now_button'].hide()
			self['now_button_sel'].hide()
			self['next_button'].hide()
			self['next_button_sel'].hide()
			self['more_button'].hide()
			self['more_button_sel'].hide()
			self['now_text'].hide()
			self['next_text'].hide()
			self['more_text'].hide()
			self['key_red'].setText('')
			self['zapTo'].setText('') #+ WeFraJo
		else:
			if state == 1:
				self['now_button_sel'].show()
				self['now_button'].hide()
			else:
				self['now_button'].show()
				self['now_button_sel'].hide()
			if state == 2:
				self['next_button_sel'].show()
				self['next_button'].hide()
			else:
				self['next_button'].show()
				self['next_button_sel'].hide()
			if state == 3:
				self['more_button_sel'].show()
				self['more_button'].hide()
			else:
				self['more_button'].show()
				self['more_button_sel'].hide()

	def onSelectionChanged(self):
		try:  #if standard EPGSearch is used
			self.isNotSearch = self.isNotSearch
		except:
			self.isNotSearch = False

		cur = self['list'].getCurrent()
		#print self['list'].getCurrentSelectionIndex()
		if cur is None:
			if self.key_green_choice != self.EMPTY:
				self['key_green'].setText('')
				self.key_green_choice = self.EMPTY
			if self.key_red_choice != self.EMPTY:
				self['key_red'].setText('')
				self['zapTo'].setText('') #+WeFraJo
				self.key_red_choice = self.EMPTY
			return
		
		if self.isNotSearch:
			# do not allow wrap around in list
			if self.type == EPG_TYPE_MULTI and not config.plugins.MyEPG.enable_wrap_multi.value:
				new_ref = str(cur[1])
				#print "xxxi ", new_ref, self.old_ref, self.first_bouquet_ref, self.last_bouquet_ref
				if self.old_ref == self.first_bouquet_ref and new_ref == self.last_bouquet_ref:
					self['list'].moveDown()
				elif self.old_ref == self.last_bouquet_ref and new_ref == self.first_bouquet_ref:
					self['list'].moveUp()
				cur = self['list'].getCurrent()
				
			if self.type == EPG_TYPE_SINGLE and not config.plugins.MyEPG.enable_wrap_single.value:
				begin = self.getCurrentInfo()[0]
				if self.single_begin_old == self.single_first and begin == self.single_last:
					self['list'].moveDown()
				if self.single_begin_old == self.single_last and begin == self.single_first:
					self['list'].moveUp()
				cur = self['list'].getCurrent()
				self.single_begin_old = self.getCurrentInfo()[0]

		#else: #-WeFraJo
		if 1 == 1: #+ WeFraJo
			event = cur[0]
			#print "WeFraJo EpgSelection onSelectionChanged1 ", cur[0], "\n", cur[1]
			self['Event'].newEvent(event)
			if self.type == EPG_TYPE_MULTI:
				count = self['list'].getCurrentChangeCount()
				if self.ask_time != -1:
					self.applyButtonState(0)
					self.myAsktime = time() #+ WeFraJo
					self.setConfigAsktime(self.myAsktime) #+ WeFraJo
				elif count > 1:
					self.applyButtonState(3)
				elif count > 0:
					self.applyButtonState(2)
				else:
					self.applyButtonState(1)
			#- start WeFraJo
				#days = [_('Mon'), _('Tue'), _('Wed'), _('Thu'), _('Fri'), _('Sat'), _('Sun')]
				#datestr = ''
				#if event is not None:
				#	now = time()
				#	beg = event.getBeginTime()
				#	nowTime = localtime(now)
				#	begTime = localtime(beg)
				#	if nowTime[2] != begTime[2]:
				#		datestr = '%s %d.%d.' % (days[begTime[6]], begTime[2], begTime[1])
				#	else:
				#		datestr = '%s %d.%d.' % (_('Today'), begTime[2], begTime[1])
				#self['askDateTime'].setText(datestr)
			#- end WeFraJo
				self.createDateLabel() #+ WeFraJo
				#self.createNextEventsList() #+ WeFraJo
				self.old_ref = str(cur[1])
				config.plugins.MyEPG.ref.setValue(self.old_ref)
				if cur[1] is None:
					self['Service'].newService(None)
				else:
					self['Service'].newService(cur[1].ref)
			if cur[1] is None or cur[1].getServiceName() == '':
				if self.key_green_choice != self.EMPTY:
					self['key_green'].setText('')
					self.key_green_choice = self.EMPTY
				if self.key_red_choice != self.EMPTY and self.type != EPG_TYPE_EPGBAR and self.type != EPG_TYPE_SINGLE:
					self['key_red'].setText('')
					self['zapTo'].setText('') #+WeFraJo
					self.key_red_choice = self.EMPTY
				return
			#+ start WeFraJo
			elif self.type == EPG_TYPE_MULTI and self.key_red_choice != self.EMPTY:
				if config.plugins.MyEPG.okAction.value != "detail":
					if str(cur[1]) == self.ref_currentPlaying and config.plugins.MyEPG.okAction.value == "curBack":
							self['zapTo'].setText('Zurück zu TV')
					else:
						self['zapTo'].setText('Auf Sender umschalten')
			self.createListInfoLabels()
			#+ end WeFraJo
			if self.key_red_choice != self.ZAP and (self.type == EPG_TYPE_MULTI or self.type == EPG_TYPE_EPGBAR or self.type == EPG_TYPE_SINGLE) and config.plugins.MyEPG.okAction.value != "detail":
				if self.zapFunc:
					#+ start WeFraJo
					#print "WeFraJo EpgSelection onSelectionChanged2 ", str(cur[1]), self.ref_currentPlaying
					if str(cur[1]) == self.ref_currentPlaying:
						if config.plugins.MyEPG.okAction.value == "curBack":
							self['zapTo'].setText('Zurück zu TV')
						else:
							self['zapTo'].setText('Auf Sender umschalten')
						#+ end WeFraJo
					self['key_red'].setText(_('Zap'))
					self.key_red_choice = self.ZAP
			if event is None:
				if self.key_green_choice != self.EMPTY:
					self['key_green'].setText('')
					self.key_green_choice = self.EMPTY
				return
			self['SelectedEvent'].setText((cur[0], cur[1])) #WeFrajo necessary??? diese 3 deaktiviert und funktioniert trotzdem alles
			self['ExtEvent'].newEvent(cur[0])  #WeFrajo necessary???
			self['ExtEvent'].newService(cur[1])  #WeFrajo necessary???
			if self.type == EPG_TYPE_MULTI: #+WeFraJo
				self.createNextEventsList() #+ WeFraJo
			if self.type == EPG_TYPE_SINGLE and self.isNotSearch: #+WeFraJo
				self.createDateLabel() #+ WeFraJo

			serviceref = cur[1]
			eventid = event.getEventId()
			refstr = serviceref.ref.toString()
			isRecordEvent = False
			isDisabled = False
			for timer in self.session.nav.RecordTimer.timer_list:
				if timer.eit == eventid and timer.service_ref.ref.toString() == refstr:
					isRecordEvent = True
					break

			if not isRecordEvent:
				for timer in self.session.nav.RecordTimer.processed_timers:
					if timer.eit == eventid and timer.service_ref.ref.toString() == refstr and timer.disabled == True:
						isDisabled = True
						break

			if isDisabled:
				#self['key_green'].setText(_('Remove timer') + '\n' + _('Enable timer')) #- WeFraJo
				self['key_green'].setText("Timer entfernen") #+WeFraJo
				self.key_green_choice = self.ENABLE_TIMER
			elif isRecordEvent:
				#self['key_green'].setText(_('Remove timer') + '\n' + _('Disable timer')) #- WeFraJo
				self['key_green'].setText("Timer entfernen") #+WeFraJo
				self.key_green_choice = self.REMOVE_TIMER
			elif not isRecordEvent and self.key_green_choice != self.ADD_TIMER:
				self['key_green'].setText(_('Add timer')) #- WeFraJo
				#self['key_green'].setText("Timer hinzufügen") #+WeFraJo
				self.key_green_choice = self.ADD_TIMER
			return
			
##########################################################################################################################
#+ start WeFraJo
##########################################################################################################################

	def init_1(self):
		self.isNotSearch = True
		try:
			config.plugins.epgsearch.add_search_to_epg.setValue(False) #disable standard EPGSearch
		except:
			pass #if standard EPGSearch not installed
		self.readInitSettings()
		#self.timer_remove_enable = "Timer entfernen/aktivieren"
		#self.timer_remove_disable = "Timer entfernen/deaktivieren"
		#self.timer_add = "Timer hinzufügen"
		self.epgcache = eEPGCache.getInstance() 
		#self.myAsktime = time()
		self['NextEvents'] = Label("")
		self['PrimeTime'] = Label("")
		self.getPrimetime()
		self['ChangeTimePlus'] = Label("")
		self['ChangeTimePlus'].setText("+ " + str(int(self.change_time / 60)) + " Min")
		self['ChangeTimeMinus'] = Label("")
		self['ChangeTimeMinus'].setText("- " + str(int(self.change_time / 60)) + " Min")
		self['NowNext'] = Label()
		self['askDateTime'] = Label("")
		self['currentListReference'] = Label()
		self['currentListNumberName'] = Label()
		self.instantToTV = False
		self.nextSel = False
		#self.backToTV = True # nur False, wenn close aus toggle
		self.ref_currentPlaying = ""
		self.ref_selected_old = ""
		self.asktime_old = self.myAsktime
		self.single_begin_old = self.single_first = self.single_last = time()
		self.begin_old = -1
		#print "WeFraJo EpgSelection init types ", EPGList, EPG_TYPE_SINGLE, EPG_TYPE_SIMILAR, EPG_TYPE_MULTI, EPG_TYPE_EPGBAR

	def init_2(self):
		self.alternative_keys = config.plugins.MyEPG.use_alternative_keys_for_timejump.value
		if self.type in (EPG_TYPE_SINGLE, EPG_TYPE_MULTI):
			if config.plugins.MyEPG.okAction.value == "detail":
				self['zapTo'].setText("Sendungs-Detailbeschreibung")
			reference = self.session.nav.getCurrentlyPlayingServiceReference().toString()
			presetTime_ended = False
			if config.plugins.MyEPG.time_using_exit_settings.value != 0 and (config.plugins.MyEPG.time_using_exit_settings.value + self.exit_time) < time() and config.plugins.MyEPG.returnAction.value == 0: 
				presetTime_ended = True
			self.reset_ref_time = False
			if (reference != self.ref_playing_on_exit and config.plugins.MyEPG.returnAction.value == 0) or presetTime_ended: 
				self.reset_ref_time = True
				config.plugins.MyEPG.ref.setValue(reference)
				self.myAsktime = int(time())
				config.plugins.MyEPG.asktime.setValue(self.myAsktime)

		if self.type == EPG_TYPE_SINGLE:
			self.single_idx = -1
			self.bouquetServices = self.getChannelList()
		if self.type == EPG_TYPE_MULTI:
			self.getChannelList()
			self.first_bouquet_ref = str(self.services[0])
			self.last_bouquet_ref = str(self.services[len(self.services)-1])
			#print "xxx4 ", self.first_bouquet_ref, self.last_bouquet_ref
			if self.myAsktime <= time():
				self['NowNext'].setText("Nächste Sendung")
			else:
				self['NowNext'].setText("Jetzt")
		else:
			self.first_bouquet_ref = None
			self.last_bouquet_ref = None

	def checkIsSearchxxx(self): #nicht mehr notwendig
		if self.isNotSearch:
			self.isSearch = False
		else:
			self.isSearch = True
		#try:
		#	tmp = self.myAsktime
		#	xlen = len(self.channellist)
		#	self.isSearch = False
		#except:
		#	self.isSearch = True

	def initSettings(self):
		return
		set_file = eEnv.resolve("${libdir}/enigma2/python/Plugins/Extensions/MyEPG/settings.txt")
		default_settings = '{"asktime": 0, "change_time": 1800, "ref": None, "ref_playing_on_exit": None}'
		if os.path.exists(set_file):
			f = open(set_file, "r")
			settings = f.read()
			f.close()
			if settings == "":
				settings = default_settings
		else:
			settings = default_settings
		try:
			settings = eval(settings)
		except:
			settings = eval(default_settings)
		self.settings = settings

	def readInitSettings(self):
		self.myAsktime = max(config.plugins.MyEPG.asktime.value, int(time()))
		self.change_time = config.plugins.MyEPG.change_time.value
		self.last_reference = config.plugins.MyEPG.ref.value
		self.old_ref = self.last_reference
		self.ref_playing_on_exit = config.plugins.MyEPG.ref_playing_on_exit.value
		#self.EventView_open = config.plugins.MyEPG.EventView.value
		self.exit_time = config.plugins.MyEPG.exit_time.value
		#self.openType = config.plugins.MyEPG.openType.value
		#self.backToTV = True
		#config.plugins.MyEPG.backToTV.setValue(self.backToTV)

	def onReturn(self):
		config.plugins.MyEPG.returnAction.setValue(0)
		self.myAsktime = max(config.plugins.MyEPG.asktime.value, int(time()))
		self.last_reference = config.plugins.MyEPG.ref.value
		#self.old_ref = self.last_reference
		self.ref_playing_on_exit = self.last_reference #self.session.nav.getCurrentlyPlayingServiceReference().toString()
		#self.EventView_open = config.plugins.MyEPG.EventView.value
		self.exit_time = time()
		#self.openType = config.plugins.MyEPG.openType.value
		self.reset_ref_time = False
		#print "xxx44 onreturn ", time(), self.myAsktime, self.last_reference, self.ref_playing_on_exit, self.exit_time
		self.onCreate()


	def dtstr(self, time):
		return strftime('%a %d.%m.%Y %H:%M:%S', localtime(time))

	def beforeClose(self):
		if self.isNotSearch:
			if self.type in (EPG_TYPE_SINGLE, EPG_TYPE_MULTI):
				try: #reference = None
					reference = self.session.nav.getCurrentlyPlayingServiceReference().toString()
				except:
					reference = None
				config.plugins.MyEPG.ref_playing_on_exit.setValue(reference)
				config.plugins.MyEPG.exit_time.setValue(time())
				config.plugins.MyEPG.returnAction.setValue(0) 
				#config.plugins.MyEPG.EventView.setValue(False)
				#config.plugins.MyEPG.openType.setValue(99)

	def beforeToggleSingleMulti(self):
		reference = self.session.nav.getCurrentlyPlayingServiceReference().toString()
		config.plugins.MyEPG.ref_playing_on_exit.setValue(reference)
		config.plugins.MyEPG.exit_time.setValue(time())
		#config.plugins.MyEPG.EventView.setValue(False)

	def toggleSingleMulti(self):
		from Screens.InfoBar import InfoBar
		#self.openType = config.plugins.MyEPG.openType.value

		#print "xxx31a togglesinglemulti start", self.type

		if self.type in (EPG_TYPE_SINGLE, EPG_TYPE_MULTI):
			if InfoBar and InfoBar.instance:
				#if self.openType != 99:
				if config.plugins.MyEPG.returnAction.value != 0:
					#config.plugins.MyEPG.openType.setValue(99)
					self.beforeClose()
					#print "xxx31c ", time()
					#self.closeRecursive = True
					config.plugins.MyEPG.returnAction.setValue(2) 
					self.close(True)
				else:
					#config.plugins.MyEPG.openType.setValue(self.type)
					config.plugins.MyEPG.returnAction.setValue(1)
					self.beforeToggleSingleMulti()

					self.xStart = Thread(target = self.afterToggleSingleMulti)
					self.xStart.start()
					t = time()
					#print "xxx51 started ", time()-t
					#self.xStart.join()
					
					if self.type == EPG_TYPE_SINGLE:
						InfoBar.openMultiServiceEPG(InfoBar.instance)
					else:
						InfoBar.openSingleServiceEPG(InfoBar.instance)
					#print "xxx51 ended ", time()-t

	def afterToggleSingleMulti(self):
		while config.plugins.MyEPG.returnAction.value == 1:
			sleep(0.1)
		sleep(0.05)
		if config.plugins.MyEPG.returnAction.value == 2:
			self.onReturn()
		else:
			self.closeScreen()


	def setChangeTime(self):
		tlist = [900, 1800, 3600, 5400, 7200]
		idx = -1
		cnt = len(tlist)
		for x in range(0, cnt):
			if tlist[x] > self.change_time:
				idx = x
				break
		idx = max(0, idx)
		self.change_time = tlist[idx]
		config.plugins.MyEPG.change_time.setValue(self.change_time)
		config.plugins.MyEPG.change_time.save()
		self['ChangeTimePlus'].setText("+ " + str(int(self.change_time / 60)) + " Min")
		self['ChangeTimeMinus'].setText("- " + str(int(self.change_time / 60)) + " Min")

	def zapActions(self, ref):
		if self.type in (EPG_TYPE_MULTI, EPG_TYPE_SINGLE):
			if ref and (ref == self.ref_currentPlaying): 
				#config.plugins.MyEPG.backToTV.setValue(True)
				if config.plugins.MyEPG.okAction.value == "curBack":
					self.closeScreen()
			else:
				if self.instantToTV:
					self.closeScreen()
				else:
					self.ref_currentPlaying = ref
					if config.plugins.MyEPG.okAction.value == "curBack":
						self['key_red'].setText('Zurück zu TV')
						self['zapTo'].setText('Zurück zu TV')
				

	def setConfigAsktime(self, val):
		val = int(float(val))
		config.plugins.MyEPG.asktime.setValue(val)

	def timeNavigation(self, xChange):
		if not self.isNotSearch:
			return
		if config.plugins.MyEPG.returnAction.value == 2:
			self.onReturn()
			return
		if self.type == EPG_TYPE_MULTI:
			xChange = int(xChange)
			self.myAsktime = int(max(self.myAsktime, time()))
			nextSelText = "Jetzt"
			if xChange == 0:
				if self.myAsktime > time():
					self.nextSel = False
					nextSelText = "Nächste Sendung"
				elif self.nextSel == True:
					self.nextSel = False
					nextSelText = "Nächste Sendung"
				else:
					self.nextSel = True
					nextSelText = "Jetzt"
				self.myAsktime = int(time())
			elif xChange == -1 or xChange == 1:
				self.nextSel = False
				beg, dur, ref , evId, evName, servName = self.getCurrentInfo()
				if xChange == -1:
					if dur == 0:
						self.myAsktime -= self.change_time
					else:
						self.myAsktime = beg - 60
						self['list'].fillMultiEPG(self.services, self.myAsktime)
						beg, dur, ref, evId, evName, servName = self.getCurrentInfo()
						self.myAsktime = beg
				else:
					if dur == 0:
						self.myAsktime += self.change_time
					else:
						self.myAsktime = beg + dur
			elif xChange != 0:
				self.nextSel = False
				self.myAsktime += int(xChange)
			self.myAsktime = int(max(self.myAsktime, time()))
			self.setConfigAsktime(self.myAsktime)
			self['list'].fillMultiEPG(self.services, self.myAsktime)
			if self.myAsktime <= time() and self.nextSel == False:
				nextSelText = "Nächste Sendung"
			self['NowNext'].setText(nextSelText)
			if self.nextSel:
				self['list'].updateMultiEPG(1)
			#self.onSelectionChanged()   #??????????
		elif self.type == EPG_TYPE_SINGLE:
			if xChange < 0:
				xChange = -86400
			elif xChange > 0:
				xChange = 86400
			self.myAsktime = int(max(self.myAsktime + xChange, time()))
			self.setConfigAsktime(self.myAsktime)
			self.serviceChangeSingleList(0)
			self.createDateLabel()


	def getCurrentInfo(self):
		cur = self['list'].getCurrent()
		if cur == None:
			return int(time()), 0, None, None, "", ""
		ref = cur[1]
		if ref is not None:
			serviceName = ref.getServiceName()
		else:
			serviceName = ""
		reference = str(ref)
		if cur[0] == None:
			return int(time()), 0, reference, None, "", ""
		#print "xxx27 currentinfo EvName, EvId, name", cur[0].getEventName(), cur[0].getEventId(), serviceName
		return cur[0].getBeginTime(), cur[0].getDuration(), reference, cur[0].getEventId(), cur[0].getEventName(), serviceName
		
	def getCurrentEpgInfo(self):
		#self.epgcache = eEPGCache.getInstance()
		begin, duration, reference, xEvId, evName, servName = self.getCurrentInfo()
		self.epgcache.startTimeQuery(eServiceReference(reference), self.myAsktime)
		xnext = self.epgcache.getNextTimeEntry()
		if xnext is not None:
			eventId = xnext.getEventId()
			#print "xxxc ", xnext, xnext.getBeginTime(), self.dtstr(xnext.getBeginTime()), eventId
		else: # there is no more EPG-info for the asked time
			nextEvList = self.epgcache.lookupEvent(['BDTI', (reference, 0, -1, 99999)])
			cnt = len(nextEvList)
			eventId = 0
			if cnt > 0:
				eventId = nextEvList[cnt-1][3]
		#print "xxxd ", eventId
		return begin, duration, reference, eventId

	def serviceChangeSingleList(self, direction):
		l = self['list']
		if direction < 0:
			direction = -1
		elif direction > 0:
			direction = 1
		if direction != 0:
			if len(self.bouquetServices) == 0 or self.single_idx == -1:
				self.serviceChangeCB(direction, self)
			else:
				#l.recalcEntrySize()
				self.single_idx = min(max(0, self.single_idx + direction), len(self.bouquetServices)-1)
				service = ServiceReference(self.bouquetServices[self.single_idx])
				l.fillSingleEPG(service)
				reference = self.getCurrentEpgInfo()[2]
				config.plugins.MyEPG.ref.setValue(reference)
				self['Service'].newService(service.ref)
		serviceId = self.getCurrentEpgInfo()[3]
		l.moveToEventId(serviceId)
		self.getFirstLastBegin()
		self.single_begin_old, dur, ref , evId, evName, servName = self.getCurrentInfo()
		if config.plugins.MyEPG.okAction.value != "detail":
			if ref == self.ref_currentPlaying and config.plugins.MyEPG.okAction.value == "curBack":
				self['zapTo'].setText('Zurück zu TV')
			else:
				self['zapTo'].setText('Auf Sender umschalten')


	def findSingleIndex(self, ref):
		cnt = len(self.bouquetServices)
		self.single_idx = -1
		idx = 0
		for x in self.bouquetServices:
			if x == self.last_reference:
				self.single_idx = idx
				break
			idx += 1

	def getFirstLastBegin(self):
		begin, duration, reference, evId, evName, servName = self.getCurrentInfo()
		nextEvList = self.epgcache.lookupEvent(['BDTI', (reference, 0, -1, 99999)])
		if len(nextEvList) > 0:
			self.single_first = nextEvList[0][0]
			self.single_last = nextEvList[-1][0]

	def createNextEventsList(self):
		cur = self['list'].getCurrent()
		reference = str(cur[1])
		xref = cur[1]
		if cur[0] == None:
			begin = self.myAsktime
		else:
			begin = cur[0].getBeginTime()
		if begin is None:
			begin = self.myAsktime
		if (reference == self.ref_selected_old) and ((self.asktime_old == self.myAsktime) or (begin == self.begin_old)):
			return
		else:
			self.ref_selected_old = reference
			self.asktime_old = self.myAsktime
			self.begin_old = begin

		nextEvList = self.epgcache.lookupEvent(['BDTI', (reference, 0, -1, 99999)])
		lines = 5
		lines_before = 0
		text = ''
		cnt = len(nextEvList)
		idx = -1
		if cnt:
			for x in range(0, cnt):
				if nextEvList[x][0] > self.myAsktime:
					idx = x
					break
			if idx == -1:
				idx = cnt - 1
			start = max(0, idx - lines_before - 1)
			end = min(cnt - 1, start + lines -1)
			start = max(0, end - lines + 1)
			#print "WeFraJo createNextEventsList ", idx, start, end
			
			for x in range (start, min(end + 1, cnt)):
				if len(nextEvList[x]) >= 3:
					#print "xxxb ", nextEvList[x], nextEvList[x][0], nextEvList[x][1], nextEvList[x][2]
					text = text + self.createEventStr(nextEvList[x])
				else:
					end += 1
		self["NextEvents"].setText(text)
		#print "text: ", text
		self.getPrimetimeEventStr()

	def createEventStr(self, event):
		begin = localtime(event[0])
		end = localtime(event[0] + event[1])
		ret = '%02d:%02d - %02d:%02d  %s\n' % (begin[3], begin[4], end[3], end[4], event[2])
		return ret

	def createDateLabel(self):
		days = ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun']
		dateStr = ''
		now = date.today()
		ask = localtime(self.myAsktime) 
		askDate = date(ask[0], ask[1], ask[2])
		askTime = datetime(ask[0], ask[1], ask[2], ask[3], ask[4])
		diff = (askDate - now).days
		appendNext = ""
		if self.nextSel and self.type == EPG_TYPE_MULTI:
			appendNext =" nächste"
		if diff == 0:
			dateStr = _('Today') + '{:  %d.%m.}'.format(askDate) + '{:	 %H:%M}'.format(askTime) + appendNext 
		else:
			dateStr = _('{:%a}'.format(askDate)) + '{:  %d.%m.}'.format(askDate) + " (+" + str(diff) + ")" + '{:  %H:%M}'.format(askTime) + appendNext
		self['askDateTime'].setText(dateStr)

	def createListInfoLabels(self):
		if not self.isNotSearch:
			return
		num = 0
		name = ""
		#cur[0].getBeginTime(), cur[0].getDuration(), reference, cur[0].getEventId(), cur[0].getEventName(), serviceName
		beg, dur, ref, evId, evName, name  = self.getCurrentInfo()
		self['currentListReference'].setText(ref)
		try:
			xlen = len(self.channellist)
		except:
			self.channellist = []
			xlen = 0
		if xlen > 0:
			#print "xxx26a ref single_idx channellist ", ref, self.channellist  #, self.single_idx
			if self.type == EPG_TYPE_SINGLE:
				idx = min(max(0, self.single_idx), xlen-1)
				num = self.channellist[idx][2]
				name = self.channellist[idx][1]
			else:
				for x in self.channellist:
					if x[0] == ref:
						num = x[2]
						name = x[1]
						break	
		numnam = ""
		if num > 0:
			numnam = str(num) + "  "
		numnam += name
		self['currentListNumberName'].setText(numnam)


	def getPrimetimeEventStr(self):
		reference = self.getCurrentInfo()[2]
		if reference == None:
			result = ""
		else:
			dt, tomorrow = self.getPrimetime()
			pt_tomorrow = ""
			if tomorrow:
				pt_tomorrow = ">>> "
			self.epgcache.startTimeQuery(eServiceReference(reference), int(mktime(dt.timetuple())))
			#print "WeFraJo EpgSelection xxx20a primetime1 ", eServiceReference(reference), int(mktime(dt.timetuple())), dt.timetuple()
			pt_event = self.epgcache.getNextTimeEntry()
			if pt_event and (pt_event.getBeginTime() <= int(mktime(dt.timetuple()))):
				begin = strftime('%H:%M', localtime(pt_event.getBeginTime()))
				end = strftime('%H:%M', localtime(pt_event.getBeginTime() + pt_event.getDuration()))
				title = pt_event.getEventName()
				duration = _('%d min') % (pt_event.getDuration() / 60)
				result = pt_tomorrow + ('%s - %s  %s' % (begin, end, title))
			else:
				result = ""
		#print "WeFraJo EpgSelection xxx20b primetime2 ", result 
		self['PrimeTime'].setText(result)
		return dt, tomorrow

	def getPrimetime(self):
		primetime_hour = 20
		primetime_minute = 17
		xerr = True
		try:
			pt = (config.misc.prev_mepg_time.value + ":").split(":")
			primetime_hour = int(pt[0])
			primetime_minute = int(pt[1])
			xerr = False
		except:
			pass
		try:	
			if xerr:
				pt = config.misc.prev_mepg_time.value
				primetime_hour = int(pt[0])
				primetime_minute = int(pt[1])
		except:
			pass
		tomorrow = False
		now = localtime(time())
		dt = datetime(now.tm_year, now.tm_mon, now.tm_mday, primetime_hour, primetime_minute,30)
		if now.tm_hour > primetime_hour or (now.tm_hour == primetime_hour and now.tm_min > primetime_minute):
			now = localtime(time() + 24*60*60)
			dt = datetime(now.tm_year, now.tm_mon, now.tm_mday, primetime_hour, primetime_minute,30)
			tomorrow = True
		#self['PrimeTime'].setText('{:02.0f}:{:02.0f}'.format(primetime_hour, primetime_minute))
		return dt, tomorrow

	def selectCurrentPlaying(self):
		self.myAsktime = int(time())
		#self.last_reference = None
		self.nextSel = False
		self.last_reference = None #self.session.nav.getCurrentlyPlayingServiceReference().toString()
		self.onCreate()
		self.nextSel = True
		self.timeNavigation(0)
		reference = self.session.nav.getCurrentlyPlayingServiceReference().toString()
		self.last_reference = reference
		config.plugins.MyEPG.ref.setValue(self.last_reference)
		if self.type == EPG_TYPE_SINGLE:
			self.findSingleIndex(reference)
			self.createListInfoLabels()
		self.myAsktime = int(time())
		config.plugins.MyEPG.asktime.setValue(self.myAsktime)

	def key_test(self):
		self.test() #pass
		#self['list'].moveUp()
		#self.editAskTime()

	def pageUp(self):
		self['list'].pageUp()

	def pageDown(self):
		self['list'].pageDown()

	def key_instantBacktoTV(self):
		self.instantToTV = True
		self.zapTo()

	def key_currentNextPlaying(self):
		if self.type == EPG_TYPE_MULTI:
			self.timeNavigation(0)
		elif self.type == EPG_TYPE_SINGLE: #set current begin_time as asktime
			l=self["list"]
			begin = self.getCurrentInfo()[0]
			self.myAsktime = int(max(time(), begin))
			self.setConfigAsktime(self.myAsktime)
			self.createDateLabel()

	def key_minus1day(self):
		self.nextSel = False
		self.timeNavigation(-86400)


	def key_minus6hours(self):
		if self.type == EPG_TYPE_MULTI:
			self.nextSel = False
			self.timeNavigation(-21600)

	def key_next(self):
		#not used
		pass

	def key_notused(self):
		pass

	def key_pageDown(self):
		self.pageDown()

	def key_pageUp(self):
		self.pageUp()
		
	def key_moveUp(self):
		#eine Zeile nach oben - noch nicht gefunden, wie man die Steuerkreuz-Tasten definieren könnte
		pass
		
	def key_moveDown(self):
		#eine Zeile nach unten - noch nicht gefunden, wie man die Steuerkreuz-Tasten definieren könnte
		pass

	def key_minusMinutes(self):
		if self.type == EPG_TYPE_MULTI and self.alternative_keys:
			self.minusMinutes()

	def minusMinutes(self):
		if self.type == EPG_TYPE_MULTI:
			self.nextSel = False
			self.timeNavigation(- self.change_time)

	def key_plusMinutes(self):
		if self.type == EPG_TYPE_MULTI and self.alternative_keys:
			self.plusMinutes()

	def plusMinutes(self):
		if self.type == EPG_TYPE_MULTI:
			self.nextSel = False
			self.timeNavigation(self.change_time)

	def key_setMinutes(self):
		if self.type == EPG_TYPE_MULTI:
			self.setChangeTime()

	def key_plus1day(self):
		self.nextSel = False
		self.timeNavigation(86400)

	def key_plus6hours(self):
		if self.type == EPG_TYPE_MULTI:
			self.nextSel = False
			self.timeNavigation(21600)

	def key_primetime(self):
		self.nextSel = False
		dt = self.getPrimetimeEventStr()[0]
		self.myAsktime = int(mktime(dt.timetuple())) + 10
		if self.type == EPG_TYPE_MULTI:
			self.timeNavigation(-10)
		if self.type == EPG_TYPE_SINGLE:
			self.serviceChangeSingleList(0)

	def getChannelList(self):
		reference = self.session.nav.getCurrentlyPlayingServiceReference().toString()
		if reference.startswith('1:0:2') or reference.startswith('1:0:A'):
			isRadioService = True
			searchstr = '1:7:2:0:0:0:0:0:0:0:(type == 2 || type == 10) FROM BOUQUET "bouquets.radio" ORDER BY bouquet'
			lastpath = config.radio.lastroot.value
		else:
			isRadioService = False
			searchstr = '1:7:1:0:0:0:0:0:0:0:(type == 1) || (type == 17) || (type == 195) || (type == 25) FROM BOUQUET "bouquets.tv" ORDER BY bouquet'
			lastpath = config.tv.lastroot.value
		if not config.usage.multibouquet.value:
			if isRadioService:
				if '||' in config.radio.lastroot.value:
					lastpath = 'FROM BOUQUET "userbouquet.favourites.radio" ORDER BY bouquet'
			else:
				if '||' in config.tv.lastroot.value:
					lastpath = 'FROM BOUQUET "userbouquet.favourites.tv" ORDER BY bouquet'
		serviceHandler = eServiceCenter.getInstance()
		services = serviceHandler.list(eServiceReference(searchstr))
		#print "xxx23d services ", services
		bouquets = services and services.getContent('SN', True)
		#print "xxx23 bouquets ", bouquets
		reflist = []
		self.channellist = []
		num = 0
		for bouquet in bouquets:
			#print "xxx23a bouquet lastpath ", bouquet, lastpath
			if bouquet[0] in lastpath:
				services = serviceHandler.list(eServiceReference(bouquet[0]))
				channels = services and services.getContent('SN', True)
				#print "xxx23 channels ", channels
				for channel in channels:
					if not channel[0].startswith('1:64:'):
						num +=1
						self.channellist.append((channel[0], channel[1].replace('\xc2\x86', '').replace('\xc2\x87', ''), num))
				break
			else:
				services = serviceHandler.list(eServiceReference(bouquet[0]))
				channels = services and services.getContent('SN', True)
				for channel in channels:
					if not channel[0].startswith('1:64:'):
						num += 1
		#print "xxx23g channellist ", self.channellist
		for ref in self.channellist:
			reflist.append(ref[0])

		#print "xxx23b reflist ", reflist
		return reflist




	def test(self): #start ChannelList
		if self.type == EPG_TYPE_MULTI:
			from Screens.InfoBar import InfoBar
			if InfoBar and InfoBar.instance:
				#print "xxx28 open channellist"
				InfoBar.openServiceList(InfoBar.instance)



#+ end WeFraJo

