# -*- coding: utf-8 -*-
# Embedded file name: /media/build/vti-dorie/build/tmp/work/armv7ahf-vfp-neon-oe-linux-gnueabi/enigma2-python/enigma2-python-vti-15.0.0-20200921-r00r01/git/lib/python/Screens/MyEventVi.py
from Screen import Screen
from Screens.ChoiceBox import ChoiceBox
from Screens.TimerEdit import TimerSanityConflict, TimerEditList
from Screens.MessageBox import MessageBox
from Components.ActionMap import ActionMap, HelpableActionMap
from Components.Button import Button
from Components.Label import Label
from Components.ScrollLabel import ScrollLabel
from Components.TimerList import TimerList
from Components.UsageConfig import preferredTimerPath
from enigma import eEPGCache, eTimer, eServiceReference, eEnv, eServiceCenter
from RecordTimer import RecordTimerEntry, parseEvent, AFTEREVENT
from TimerEntry import TimerEntry
from time import time, localtime, strftime #+ WeFraJo strftime
from Components.config import config
import Tools.AutoTimerHook as AutoTimerHook
import os


class EventViewBase:
	ADD_TIMER = 0
	REMOVE_TIMER = 1

	def __init__(self, Event, Ref, callback = None, similarEPGCB = None):
		if not AutoTimerHook.CHECKAUTOTIMER:
			AutoTimerHook.initAutoTimerGlobals()
		self.screentitle = _('Eventview')
		self.similarEPGCB = similarEPGCB
		self.cbFunc = callback
		self.currentService = Ref
		path = Ref.ref.getPath()
		self.isRecording = not Ref.ref.flags & eServiceReference.isGroup and path
		if path.find('://') != -1:
			self.isRecording = None
		self.event = Event
		self['epg_description'] = ScrollLabel()
		self['datetime'] = Label()
		self['EventDate'] = Label() #+ WeFraJo
		self['EventTime'] = Label() #+ WeFraJo
		self['currentListNumberName'] = Label()  #+ WeFraJo
		#self['currentListReference'] = Label()  #+ WeFraJo
		self['Similar'] = Label()
		self['channel'] = Label()
		self['duration'] = Label()
		self['key_red'] = Button('')
		if similarEPGCB is not None:
			self.SimilarBroadcastTimer = eTimer()
			self.SimilarBroadcastTimer.callback.append(self.getSimilarEvents)
		else:
			self.SimilarBroadcastTimer = None
		self.key_green_choice = self.ADD_TIMER
		if self.isRecording:
			self['key_green'] = Button('')
		else:
			self['key_green'] = Button(_('Add timer'))
		self['key_yellow'] = Button('')
		self['key_blue'] = Button('')
		self['actions'] = ActionMap(['OkCancelActions', 'myEventViewActions'], {'cancel': self.close,
		 'ok': self.close,
		 'pageUp': self.pageUp,
		 'pageDown': self.pageDown,
		 'prevEvent': self.prevEvent,
		 'nextEvent': self.nextEvent,
		 'timerAdd': self.timerAdd,
		 'instantTimer': self.addInstantTimer,
		 'openSimilarList': self.openSimilarList})
		self['menu_actions'] = HelpableActionMap(self, 'MenuActions', {'menu': (self.menuClicked, _('Setup'))}, -2)
		self.getChannelList()
		self.onShown.append(self.onCreate)
		return


	def menuClicked(self):
		return #+ WeFraJo
		from Plugins.SystemPlugins.VTIPanel.EPGPanel import EPGPanel
		self.session.open(EPGPanel, '/usr/lib/enigma2/python/Plugins/systemPlugins/VTIPanel')

	def onCreate(self):
		self.setService(self.currentService)
		self.setEvent(self.event)
		self.setTitle(self.screentitle)


	def prevEvent(self):
		if self.cbFunc is not None:
			self.cbFunc(self.setEvent, self.setService, -1)
		return

	def nextEvent(self):
		if self.cbFunc is not None:
			self.cbFunc(self.setEvent, self.setService, +1)
		return

	def removeTimer(self, timer):
		timer.afterEvent = AFTEREVENT.NONE
		self.session.nav.RecordTimer.removeEntry(timer)
		self['key_green'].setText(_('Add timer'))
		self.key_green_choice = self.ADD_TIMER

	def addInstantTimer(self):
		self.timerAdd(True)

	def timerAdd(self, instantTimer = False):
		if self.isRecording:
			return
		else:
			event = self.event
			serviceref = self.currentService
			if event is None:
				return
			eventid = event.getEventId()
			refstr = serviceref.ref.toString()
			for timer in self.session.nav.RecordTimer.timer_list:
				if timer.eit == eventid and timer.service_ref.ref.toString() == refstr:
					if instantTimer:
						self.removeTimer(timer)
						break
					else:
						cb_func = lambda ret: not ret or self.removeTimer(timer)
						self.session.openWithCallback(cb_func, MessageBox, _('Do you really want to delete %s?') % event.getEventName())
						break
			else:
				newEntry = RecordTimerEntry(self.currentService, checkOldTimers=True, dirname=preferredTimerPath(), *parseEvent(self.event))
				if instantTimer:
					self.session.nav.RecordTimer.saveTimer()
					self.finishedAdd((True, newEntry))
				elif AutoTimerHook.AUTOTIMER_OK and config.usage.ask_for_timer_typ.value:
					self.session.openWithCallback(self.askTimerType, ChoiceBox, title=_('Select timer type...'), list=AutoTimerHook.getChoiceList())
				else:
					self.session.openWithCallback(self.finishedAdd, TimerEntry, newEntry)

			return

	def askTimerType(self, ret = None):
		if ret:
			event = self.event
			serviceref = self.currentService
			if event is None:
				return
			if ret[1] == 'default':
				newEntry = RecordTimerEntry(serviceref, checkOldTimers=True, dirname=preferredTimerPath(), *parseEvent(event))
				self.session.openWithCallback(self.finishedAdd, TimerEntry, newEntry)
			elif ret[1] == 'autotimer':
				AutoTimerHook.addAutotimerFromEvent(self.session, evt=event, service=serviceref)
			elif ret[1] == 'show_autotimer':
				AutoTimerHook.AutoTimerOverView(self.session)
			elif ret[1] == 'show_timerlist':
				self.session.open(TimerEditList)
		return

	def finishedAdd(self, answer):
		vtilog('finished add')
		if answer[0]:
			entry = answer[1]
			simulTimerList = self.session.nav.RecordTimer.record(entry)
			if simulTimerList is not None:
				for x in simulTimerList:
					if x.setAutoincreaseEnd(entry):
						self.session.nav.RecordTimer.timeChanged(x)

				simulTimerList = self.session.nav.RecordTimer.record(entry)
				if simulTimerList is not None:
					self.session.openWithCallback(self.finishSanityCorrection, TimerSanityConflict, simulTimerList)
			self['key_green'].setText(_('Remove timer'))
			self.key_green_choice = self.REMOVE_TIMER
		else:
			self['key_green'].setText(_('Add timer'))
			self.key_green_choice = self.ADD_TIMER
			vtilog('Timeredit aborted')
		return

	def finishSanityCorrection(self, answer):
		self.finishedAdd(answer)

	def setService(self, service):
		self.currentService = service
		if self.isRecording:
			self['channel'].setText(_('Recording'))
		else:
			self.createNumberNameLabel()  #+WeFraJo
			#name = self.currentService.getServiceName()  #- WeFraJo
			#if name is not None:  #- WeFraJo
			#	self['channel'].setText(name)  #- WeFraJo
			#else:  #- WeFraJo
			#	self['channel'].setText(_('unknown service'))  #- WeFraJo
		return

	def sort_func(self, x, y):
		if x[1] < y[1]:
			return -1
		elif x[1] == y[1]:
			return 0
		else:
			return 1

	def setEvent(self, event):
		self.event = event
		if event is None:
			return
		else:
			text = event.getEventName()
			#short = event.getShortDescription() #- WeFraJo
			short = event.getShortDescription().replace(chr(10)+chr(10)+chr(10),chr(10)+chr(10)).replace("\n\n\n","\n\n") #+ WeFraJo
			ext = event.getExtendedDescription()
			#+ start WeFraJo
			if short.startswith(text):
				short = short.replace(text , "")
				while ord((short+" ")[0:1]) == 10:
					short = short[1:]
				while short.startswith(chr(92)):
					short = short[2:]
				while short.startswith(" "):
					short = short[1:]
			#+ end WeFraJo
			if short and short != text:
				text += '\n\n' + short
			if ext:
				if text:
					text += '\n\n'
				text += ext
			#+ start WeFraJO
			len_old = len(text)
			while True:
				text = text.replace(chr(10)+chr(10)+chr(10),chr(10)+chr(10)).replace("\n\n\n","\n\n") #+ WeFraJo
				if len(text) == len_old:
					break
				else:
					len_old = len(text)
			#+ end WeFraJo
			if 'epg_description' not in self:
				return
			self['epg_description'].setText(text)
			self.getDateTime() #+ WeFraJo
			#self['datetime'].setText(event.getBeginTimeString()) #- WeFraJo
			#self['duration'].setText(_('%d min') % (event.getDuration() / 60)) #- WeFraJo
			self['key_red'].setText('')
			if self.SimilarBroadcastTimer is not None:
				self.SimilarBroadcastTimer.start(400, True)
			serviceref = self.currentService
			#print "xxx29 ref ", serviceref
			eventid = self.event.getEventId()
			refstr = serviceref.ref.toString()
			isRecordEvent = False
			for timer in self.session.nav.RecordTimer.timer_list:
				if timer.eit == eventid and timer.service_ref.ref.toString() == refstr:
					isRecordEvent = True
					break

			if isRecordEvent and self.key_green_choice != self.REMOVE_TIMER:
				self['key_green'].setText(_('Remove timer'))
				self.key_green_choice = self.REMOVE_TIMER
			elif not isRecordEvent and self.key_green_choice != self.ADD_TIMER:
				self['key_green'].setText(_('Add timer'))
				self.key_green_choice = self.ADD_TIMER
			return

	def pageUp(self):
		self['epg_description'].pageUp()

	def pageDown(self):
		self['epg_description'].pageDown()

	def getSimilarEvents(self):
		refstr = str(self.currentService)
		id = self.event.getEventId()
		epgcache = eEPGCache.getInstance()
		ret = epgcache.search(('NB',
		 100,
		 eEPGCache.SIMILAR_BROADCASTINGS_SEARCH,
		 refstr,
		 id))
		text = "" #+ WeFraJo
		if ret is not None:
			#descr = self['epg_description']  #- WeFraJo
			#text = descr.getText() #- WeFraJo
			#text += '\n\n' + _('Similar broadcasts:') #- WeFraJo
			text = _('Similar broadcasts:') #+ WeFraJo
			ret.sort(self.sort_func)
			#print "xxx51 similar ret ", ret
			for x in ret:
				t = localtime(x[1])
				text += '\n%d.%d.%d, %02d:%02d  -  %s' % (t[2], t[1], t[0], t[3], t[4], x[0])
			#descr.setText(text) #- WeFraJo
			self['key_red'].setText(_('Similar'))
		self['Similar'].setText(text)
		#self['Similar'] = Label(text)
		#print "xxx51 similar text ", text
		return

	def openSimilarList(self):
		if self.similarEPGCB is not None and self['key_red'].getText():
			id = self.event and self.event.getEventId()
			refstr = str(self.currentService)
			if id is not None:
				self.similarEPGCB(id, refstr)
		return

#######################################################################################################################
# mods by WeFraJo
#######################################################################################################################

	def getDateTime(self):
		#+ start WeFraJo
		event = self.event
		beg = localtime(event.getBeginTime()) 
		dur = event.getDuration()
		end = localtime(event.getBeginTime() + dur) 
		t_fmt = "%H:%M"
		beg_str = strftime(t_fmt, beg)
		end_str = strftime(t_fmt, end)
		d_fmt = "%a, %d. %b %Y"
		for a in ("%a", "%A", "%B", "%b"):
			d_fmt = d_fmt.replace(a, _(strftime(a, beg)))
		date_str = strftime(d_fmt, beg)
		self['datetime'].setText(beg_str + "   " + date_str)
		self['EventDate'].setText(date_str)
		self['EventTime'].setText(beg_str + "  -  " + end_str)
		self['duration'].setText(_('%d min') % (dur / 60))

	def getChannelList(self):
		reference = self.session.nav.getCurrentlyPlayingServiceReference().toString()
		if reference.startswith('1:0:2') or reference.startswith('1:0:A'):
			isRadioService = True
			searchstr = '1:7:2:0:0:0:0:0:0:0:(type == 2 || type == 10) FROM BOUQUET "bouquets.radio" ORDER BY bouquet'
			lastpath = config.radio.lastroot.value
		else:
			isRadioService = False
			searchstr = '1:7:1:0:0:0:0:0:0:0:(type == 1) || (type == 17) || (type == 195) || (type == 25) FROM BOUQUET "bouquets.tv" ORDER BY bouquet'
			lastpath = config.tv.lastroot.value
		if not config.usage.multibouquet.value:
			if isRadioService:
				if '||' in config.radio.lastroot.value:
					lastpath = 'FROM BOUQUET "userbouquet.favourites.radio" ORDER BY bouquet'
			else:
				if '||' in config.tv.lastroot.value:
					lastpath = 'FROM BOUQUET "userbouquet.favourites.tv" ORDER BY bouquet'
		serviceHandler = eServiceCenter.getInstance()
		services = serviceHandler.list(eServiceReference(searchstr))
		#print "xxx23d services ", services
		bouquets = services and services.getContent('SN', True)
		#print "xxx23 bouquets ", bouquets
		reflist = []
		self.channellist = []
		num = 0
		for bouquet in bouquets:
			#print "xxx23a bouquet lastpath ", bouquet, lastpath
			if bouquet[0] in lastpath:
				services = serviceHandler.list(eServiceReference(bouquet[0]))
				channels = services and services.getContent('SN', True)
				#print "xxx23 channels ", channels
				for channel in channels:
					if not channel[0].startswith('1:64:'):
						num +=1
						self.channellist.append((channel[0], channel[1].replace('\xc2\x86', '').replace('\xc2\x87', ''), num))
				break
			else:
				services = serviceHandler.list(eServiceReference(bouquet[0]))
				channels = services and services.getContent('SN', True)
				for channel in channels:
					if not channel[0].startswith('1:64:'):
						num += 1
		#print "xxx23g channellist ", self.channellist
		for ref in self.channellist:
			reflist.append(ref[0])

		#print "xxx23b reflist ", reflist
		return reflist

	def createNumberNameLabel(self):
		serviceref = self.currentService
		ref = ""
		if serviceref is not None:
			name = serviceref.getServiceName()
		ref = str(serviceref)
		num = 0
		name = ""
		#self['currentListReference'].setText(ref)
		xlen = len(self.channellist)
		if xlen > 0:
			for x in self.channellist:
				if x[0] == ref:
					num = x[2]
					name = x[1]
					break	
		numnam = ""
		if num > 0:
			numnam = str(num) + "  "
		numnam += name
		self['currentListNumberName'].setText(numnam)





#######################################################################################################################

class EventViewSimple(Screen, EventViewBase):

	def __init__(self, session, Event, Ref, callback = None, similarEPGCB = None):
		Screen.__init__(self, session)
		self.skinName = 'myEventView'
		EventViewBase.__init__(self, Event, Ref, callback, similarEPGCB)


class EventViewEPGSelect(Screen, EventViewBase):

	def __init__(self, session, Event, Ref, callback = None, singleEPGCB = None, multiEPGCB = None, similarEPGCB = None):
		#print "WeFraJo EventView xxxo ", session, Event, Ref, Ref.ref, callback, singleEPGCB, multiEPGCB, similarEPGCB
		Screen.__init__(self, session)
		self.xRef = str(Ref.ref)
		self.siE = singleEPGCB
		self.muE = multiEPGCB
		self.skinName = 'myEventView'
		EventViewBase.__init__(self, Event, Ref, callback, similarEPGCB)
		self['key_yellow'].setText(('Single-EPG'))
		self['key_blue'].setText(('Multi-EPG'))
		self['epgactions'] = ActionMap(['EventViewEPGActions'], {'openSingleServiceEPG': self.key_single,
		 'openMultiServiceEPG': self.key_multi})

	def key_multi(self):
		self.beforeStart()
		#from Screens.InfoBar import InfoBar
		#if InfoBar and InfoBar.instance:
		#	InfoBar.openMultiServiceEPG(InfoBar.instance)
		self.muE()

	def key_single(self):
		self.beforeStart()
		#from Screens.InfoBar import InfoBar
		#if InfoBar and InfoBar.instance:
		#	InfoBar.openSingleServiceEPG(InfoBar.instance)
		self.siE()

	def beforeStart(self):
		config.plugins.MyEPG.ref.setValue(self.xRef)
		config.plugins.MyEPG.asktime.setValue(time())
		config.plugins.MyEPG.exit_time.setValue(time())
		config.plugins.MyEPG.ref_playing_on_exit.setValue(self.xRef)



class EventViewMovieEvent(Screen):

	def __init__(self, session, name = None, ext_desc = None, dur = None):
		Screen.__init__(self, session)
		self.screentitle = _('Eventview')
		self.skinName = 'myEventView'
		self.duration = ''
		if dur:
			self.duration = dur
		self.ext_desc = ''
		if name:
			self.ext_desc = name + '\n\n'
		if ext_desc:
			self.ext_desc += ext_desc
		self['epg_description'] = ScrollLabel()
		self['datetime'] = Label()
		self['EventDate'] = Label()
		self['EventTime'] = Label()
		self['channel'] = Label()
		self['duration'] = Label()
		self['key_red'] = Button('')
		self['key_green'] = Button('')
		self['key_yellow'] = Button('')
		self['key_blue'] = Button('')
		self['actions'] = ActionMap(['OkCancelActions', 'myEventViewActions'], {'cancel': self.close,
		 'ok': self.close,
		 'pageUp': self.pageUp,
		 'pageDown': self.pageDown})
		self.onShown.append(self.onCreate)

	def onCreate(self):
		self.setTitle(self.screentitle)
		self['epg_description'].setText(self.ext_desc)
		self['duration'].setText(self.duration)

	def pageUp(self):
		self['epg_description'].pageUp()

	def pageDown(self):
		self['epg_description'].pageDown()
		
